<template>
  <el-col :span="16" :offset="6">
    <el-form label-width="100px" ref="formRef" :model="form">
      <el-form-item label="采购员" v-if="taskDefinitionKey == 'purchaseLeader'" prop="technicianId"
        style="margin-bottom: 20px" :rules="{
          required: true,
          message: '请选择',
          trigger: 'change'
        }">
        <el-select v-model="form.technicianId" clearable style="width: 100%" :filterable="true">
          <el-option v-for="item in userOptions" @click.native="form.userName = item.name" :key="item.id"
            :label="item.name" :value="item.id" />
        </el-select>
      </el-form-item>

      <el-form-item label="审批建议" prop="reason" style="margin-bottom: 20px" :rules="{
        required: true,
        message: '请选择',
        trigger: 'change'
      }">
        <el-input type="textarea" v-model="form.reason" placeholder="请输入审批建议" />
      </el-form-item>
    </el-form>
    <div style="margin-left: 10%; margin-bottom: 20px; font-size: 14px" v-if="clientEnvironmentId == 3">
      <el-button icon="el-icon-edit-outline" type="success" size="mini" @click="handleAudit(1)">通过
      </el-button>

      <el-button icon="el-icon-circle-close" v-if="taskDefinitionKey != 'purchaseLeader'" type="danger" size="mini" @click="handleAudit(0)">驳回
      </el-button>

    </div>

    <!-- 索尔 -->
    <div style="margin-left: 10%; margin-bottom: 20px; font-size: 14px" v-if="clientEnvironmentId == 2">
      <el-button icon="el-icon-edit-outline" type="success" size="mini" @click="handleAudit2(1)">通过
      </el-button>

      <el-button icon="el-icon-circle-close" type="danger" size="mini" @click="handleAudit2(0)">驳回
      </el-button>

    </div>

  </el-col>
</template>

<script>


import { approveTaskWithVariables } from '@/api/bpm/task';
import { listAllUserBind } from '@/api/system/organization';
import { outsourceAssign, outsourceNotPass } from '@/api/bpm/components/outsourcedWarehousing/index';

// 流程实例的详情页，可用于审批
export default {
  name: '',
  components: {

  },
  props: {
    businessId: {
      default: ''
    },
    taskId: {
      default: ''
    },
    id: {
      default: ''
    },

    taskDefinitionKey: {
      default: ''
    }
  },
  data() {
    return {
      form: {
        technicianId: '',
        reason: ''
      },

      userOptions: []

    };
  },

  computed: {
    clientEnvironmentId() {
      return this.$store.state.user.info.clientEnvironmentId;
    },
  },
  created() {
    if (this.taskDefinitionKey == 'purchaseLeader')
      this.userOptionsFn()
  },
  methods: {

    userOptionsFn() {
      this.userOptions = [];
      listAllUserBind().then((data) => {
        this.userOptions.push(...data);
      });
    },

    async handleAudit(status) {

      if (this.taskDefinitionKey == 'purchaseLeader') { // 采购主管审核
        this._approveTaskPurchaseLeader(status)
      } else if (this.taskDefinitionKey == 'deptLeader') {
        this._approveTaskWithVariables(status);
      }


    },


    handleAudit2(status) {
      this._approveTaskThorVariables(status)
    },

    async _approveTaskWithVariables(status) {
      let variables = {
        pass: !!status
      };

      approveTaskWithVariables({
        id: this.taskId,
        reason: this.form.reason,
        variables
      }).then((res) => {
        if (res.data.code != '-1') {
          this.$emit('handleAudit', {
            status,
            title: status === 0 ? '驳回' : ''
          });
        }
      });
    },


    async _approveTaskPurchaseLeader(status) {


      if (status == 1) {

        outsourceAssign({
          businessId: this.businessId,
          id: this.taskId,
          userId: this.form.technicianId,
          userName: this.form.userName,
          reason: this.form.reason,
          pass: true

        }).then((res) => {
          this.$emit('handleAudit', {
            status,
            title: ''
          });
        });
      } else if (status == 0) {
        outsourceNotPass({
          id: this.taskId,
          reason: this.form.reason,
          pass: false
        }).then((res) => {
          this.$emit('handleAudit', {
            status,
            title: '驳回'
          });
        });
      }

    },



    async _approveTaskThorVariables(status) {


      if (status == 1) {

        outsourceAssign({
          businessId: this.businessId,
          id: this.taskId,
          reason: this.form.reason,
          pass: true

        }).then((res) => {
          this.$emit('handleAudit', {
            status,
            title: ''
          });
        });
      } else if (status == 0) {
        outsourceNotPass({
          id: this.taskId,
          reason: this.form.reason,
          pass: false
        }).then((res) => {
          this.$emit('handleAudit', {
            status,
            title: '驳回'
          });
        });
      }

    },



  }
};
</script>

<style lang="scss"></style>
